# init bundle
source "%val{config}/bundle/kak-bundle/rc/kak-bundle.kak"
bundle-noload kak-bundle https://codeberg.org/jdugan6240/kak-bundle

bundle inc-dec.kak https://gitlab.com/Screwtapello/kakoune-inc-dec %{
	map -docstring "increment" global normal <c-a> %{: inc-dec-modify-numbers + %val{count}<ret>}
	map -docstring "decrement" global normal <c-x> %{: inc-dec-modify-numbers - %val{count}<ret>}
}

bundle auto-pairs.kak https://github.com/alexherbo2/auto-pairs.kak %{
	enable-auto-pairs
}

bundle fzf.kak https://github.com/andreyorst/fzf.kak %{
	require-module fzf
	set-option global fzf_highlight_command "bat"
	require-module fzf-grep
	set-option global fzf_grep_command "rg"
	require-module fzf-file
	set-option global fzf_file_command "fd . --no-ignore-vcs"
	map -docstring "fzf mode" global user f ": fzf-mode<ret>"
}

bundle luar https://github.com/gustavo-hms/luar %{
	require-module luar
}

bundle easymotion.kak https://git.sr.ht/~voroskoi/easymotion.kak %{
	require-module easymotion
	unmap global easymotion h
	unmap global easymotion j
	unmap global easymotion k
	unmap global easymotion l
	map global normal <ret> ': enter-user-mode easymotion<ret>'

	map global easymotion -docstring %{easymotion line ↓} <n> ": easymotion-j<ret>"
	map global easymotion -docstring %{easymotion line ↑} <e> ": easymotion-k<ret>"
	map global easymotion -docstring %{easymotion streak →} <i> ": easymotion-streak-forward<ret>"
	map global easymotion -docstring %{easymotion streak ←} <m> ": easymotion-streak-backward<ret>"
	set-option global easymotion_chars "tnseriplfuwydhcxoaqz"
}

bundle byline.kak https://github.com/evanrelf/byline.kak %{
	require-module "byline"
}

bundle case.kak https://gitlab.com/FlyingWombat/case.kak %{
	map global normal '`' ': enter-user-mode case<ret>'
}

bundle kakoune-hump https://github.com/delapouite/kakoune-hump %{
	map global normal <c-b> ': select-previous-hump<ret>' -docstring 'select prev hump'
	map global normal <c-w> ': select-next-hump<ret>'     -docstring 'select next hump'
	map global normal <c-B> ': extend-previous-hump<ret>' -docstring 'extend prev hump'
	map global normal <c-W> ': extend-next-hump<ret>'     -docstring 'extend next hump'
}

bundle kakoune-buffers https://github.com/Delapouite/kakoune-buffers %{
	map global user b ': enter-buffers-mode<ret>' -docstring 'buffers'
}

bundle vertical-selection https://github.com/occivink/kakoune-vertical-selection %{
	declare-user-mode vertical-selection
	map -docstring "select alike down" global vertical-selection n ': vertical-selection-down<ret>'
	map -docstring "select alike up" global vertical-selection e ': vertical-selection-up<ret>'
	map -docstring "select alike up & down" global vertical-selection v ': vertical-selection-up-and-down<ret>'
	map global user v ": enter-user-mode vertical-selection<ret>"

}

bundle kakoune-text-objects https://github.com/Delapouite/kakoune-text-objects %{
	map global user s ': enter-user-mode selectors<ret>' -docstring 'selectors'
}

bundle smarttab.kak https://github.com/andreyorst/smarttab.kak %{
	require-module smarttab
	set-option global softtabstop 2
	hook global BufCreate .* %{
		editorconfig-load
		autoconfigtab
	}
}

bundle pykak https://github.com/tomKPZ/pykak
